
<template>
    <div>
        <div class="dropdown-trigger"
             @click.prevent="isOpen = ! isOpen"
             aria-haspopup="true"
             :aria-expanded="isOpen"
        >
            <slot name="trigger"></slot>
        </div>
    </div>
</template>

<script>
    export default {
        name: "ModalComponent",
        props: ["name"],
        data() {
            return {
                isOpen: false
            };
        },
        methods: {
            closeButton() {
                this.isOpen = false;
            },
            watch: {
                isOpen(isOpen) {

                    if (isOpen) {
                        document.addEventListener(
                            'click',
                            this.closeIfClickedOutside
                        );
                    }
                }
            },
            closeIfClickedOutside(event) {
                if (! event.target.closest('.mobile-nav')) {
                    this.isOpen = false;
                    document.removeEventListener('click', this.closeIfClickedOutside);
                }
            }
        },
    }
</script>

<style scoped>
    .pop-out-quick-enter-active,
    .pop-out-quick-leave-active {
        transition: all 0.4s;
    }
    .pop-out-quick-enter,
    .pop-out-quick-leave-active {
        opacity: 0;
    }

    .z-9999 {
        z-index: 9999;
    }
</style>
